/*
 * NewRegist.java
 *
 * DATE : 2009/08/02 12:28
 */
import com.nttdocomo.ui.Panel;
import com.nttdocomo.ui.Display;
import com.nttdocomo.ui.IApplication;
import com.nttdocomo.ui.KeyListener;
import com.nttdocomo.ui.SoftKeyListener;


import com.nttdocomo.ui.*;

import java.util.Vector;
import java.lang.String;
import java.util.Hashtable;

/**
 * NewRegist
 *
 * @author NAME
 */
public class SelectFloorItem extends Panel implements SoftKeyListener, KeyListener, ComponentListener
{
	private RegistPanel prevPanel;
	private int   floor;
	
	Label	lblLabel;
	Label	lblNo;
	
	private ListBox[][] lstFloor = new ListBox[4][2];
	private ListBox[][] lstType = new ListBox[4][3];
	private ListBox[][] lstItem = new ListBox[4][3];
	private Label[][]	areaLbl = new Label[17][4];
	/*
	ListBox List;
	*/
	
	private Button[] areaBtn = new Button[17];
	
	SuperDataArea[][] dflr = new DataAreaFloor[4][2];
	DataAreaItems[][] ditms = new DataAreaItems[4][3];
	
    SelectFloorItem(Panel prevPanel, int floor, Vector floors)
    {
    	int i, j;
    	
    	// plAwtA̕ۑ
    	this.prevPanel = (RegistPanel) prevPanel;
    	this.floor = floor;
    	
    	setTitle(floor + "F");	// ^Cgݒ
		
        DataFloor dataFloor = null;
        DataAreaItem dataAreaItem = null;
        int	setItemIdx;
        int	setRankIdx;
        // S
		for ( i = 0; i < 4; i++ ) {
			// f[^΁A
			if ( floors != null && i < floors.size() ) {
				dataFloor = (DataFloor) floors.elementAt(i);
			} else {
				dataFloor = null;
			}
			// eR܂ł̓o^
			for ( j = 0; j < 3; j++ ) {
				if ( j < 2 ) {
					dflr[i][j] = new DataAreaFloor();
				}
				ditms[i][j] = new DataAreaItems();
				lstType[i][j] = ditms[i][j].GetTypeList();
				if ( dataFloor == null || j >= dataFloor.items.size() ) {
					// ݒf[^ȂAl
					setItemIdx = 0;
					setRankIdx = 0;
				} else {
					// ݒf[^擾
					dataAreaItem = (DataAreaItem) dataFloor.items.elementAt(j);
					// N̐ݒ
					setRankIdx = Integer.parseInt(dataAreaItem.type) - 1;
					if ( setRankIdx < 0 ) {
						setRankIdx = 0;
					}
					//System.out.println("setRankIdx:" + setRankIdx );
					// N̑I
					lstType[i][j].select( setRankIdx );
					// I
					setItemIdx = dataAreaItem.getSelIdx();
					if ( setItemIdx < 0 ) {
						setItemIdx = 0;
					}
				}
				// ΏۃÑf[^擾AI
				lstItem[i][j] = ditms[i][j].GetNameList(setRankIdx + 1);
				lstItem[i][j].select( setItemIdx );
			}
		}
		
        HTMLLayout layout = new HTMLLayout();
		setLayoutManager(layout);
		
        layout.begin(HTMLLayout.LEFT);
        for ( i = 0; i < 4; i++ ) {
        	lstFloor[i][0] = dflr[i][0].GetList();
        	lstFloor[i][1] = dflr[i][1].GetList();
	        this.add( lstFloor[i][0] );
	        lblNo = new Label("");
	       	this.add( lblNo );
	        this.add( lstFloor[i][1] );
	        layout.br();
			for ( j = 0; j < 3; j++ ) {
				this.add( lstType[i][j] );
				this.add( lstItem[i][j] );
				layout.br();
			}
		}
		layout.br();
        
        layout.end();
        
        if ( floors != null ) {
        	for ( i = 0; i < floors.size(); i++ ) {
        		dataFloor = (DataFloor) floors.elementAt(i);
	        	lstFloor[i][0].select(dataFloor.space[i][0]);
	        	lstFloor[i][1].select(dataFloor.space[i][1]);
	        }
        }
		
		//\tgL[̃xɕ\ݒ
		this.setSoftLabel(Frame.SOFT_KEY_1, "ݒ");
		this.setSoftLabel(Frame.SOFT_KEY_2, "f");

		//L[Xi̐ݒ
		this.setSoftKeyListener((SoftKeyListener)this);
		this.setKeyListener((KeyListener)this);
		this.setComponentListener(this);
	    
    }

    public void softKeyPressed(int softKey) {
    }
    
    public void softKeyReleased(int softKey) {
        if (softKey == SOFT_KEY_1) {
        	int[] floor = new int[2];
        	String strFloor = new String();
        	int itemIdx;
        	String itemName;
        	Vector itemNames = new Vector();
        	DataFloor dataFloor = null;
        	DataAreaItem areaItem;
        	
        	for ( int i = 0; i < 4; i++ ) {
	        	floor[0] = lstFloor[i][0].getSelectedIndex();
	        	if ( floor[0] > 0 ) {
		        	floor[1] = lstFloor[i][1].getSelectedIndex();
	        		if ( floor[1] > 0 ) {
	        			strFloor = lstFloor[i][1].getItem(floor[0]) + "" + lstFloor[i][1].getItem(floor[1]);
	        		} else {
	        			strFloor = lstFloor[i][1].getItem(floor[0]) + "";
	        		}
	        		itemNames.removeAllElements();
	        		dataFloor = new DataFloor();
	        		for ( int j = 0; j < 3; j++ ) {
	        			itemIdx = lstItem[i][j].getSelectedIndex();
	        			if ( itemIdx > 0 ) {
	        				itemName = lstItem[i][j].getItem(itemIdx);
	        				areaItem = ditms[i][j].GetAreaItem(itemName);
	        				if ( areaItem != null ) {
		        				itemNames.addElement(itemName);
		        				areaItem.setSelIdx(itemIdx);
		        				dataFloor.addElement(areaItem);
		        			}
	        			}
	        		}
	        		
	        		dataFloor.setSpace( i, floor[0], floor[1]);
	        		prevPanel.setData( this.floor, i, dataFloor, strFloor, ditms[i][0].GetRankList(itemNames));
	        	}
        	}
        	
            Display.setCurrent( prevPanel );
        } else {
        	IApplication.getCurrentApp().terminate();
        }
    }
    
    public void keyPressed(Panel panel, int key) {
    }
    
    public void keyReleased(Panel panel, int key) {
        switch (key) {
            case Display.KEY_1:
                break;
            case Display.KEY_2:
                break;
            case Display.KEY_3:
                break;
            default:
                break;
        }
    }
    public void componentAction(Component c, int type, int param)
    {
    	// 
    	for ( int i = 0; i < 4; i++ ) {
    		for ( int j = 0; j < 3; j++ ) {
    			if ( c == lstType[i][j] ) {
    				// ʂύXꂽƂAItem 폜ݒ
    				lstItem[i][j].removeAll();
    				lstItem[i][j].setItems( ditms[i][j].GetNameListToArray((lstType[i][j].getSelectedIndex()+1) + ""));
    				break;
    			}
    		}
    	}
    }
}
