/*
 * DQ9_Treasure.java
 *
 * DATE : 2009/08/02 12:05
 */
import com.nttdocomo.ui.IApplication;
import com.nttdocomo.ui.Display;
import com.nttdocomo.ui.Panel;
import com.nttdocomo.ui.Frame;
import com.nttdocomo.ui.Button;

import com.nttdocomo.ui.KeyListener;
import com.nttdocomo.ui.SoftKeyListener;
import com.nttdocomo.ui.ComponentListener;
import com.nttdocomo.ui.Component;

import com.nttdocomo.ui.HTMLLayout;


/**
 * DQ9_Treasure
 *
 * @author NAME
 */
public class DQ9_Treasure extends IApplication
{

    public void start() {
        Display.setCurrent((Frame)new MainPanel());
    }
}

/**
 * MainPanel
 * 
 */
class MainPanel extends Panel implements SoftKeyListener, KeyListener, ComponentListener{

	private Button newBtn;		// VKo^{^
	private Button listBtn;		// o^Xg{^
	private Button endBtn;		// I{^
	
	private Panel  newPanel;	// VKo^{^ 
	private Panel  listPanel;	// I

	/**
	 * RXgN^
	 */
    MainPanel() {
    	setTitle("DQIX TREASURE V1.00");	// ^Cg
		
        setSoftLabel(SOFT_KEY_1, "END");
        
        // {^
        newBtn	= new Button("VK쐬");
        listBtn = new Button("o^Xg");
        endBtn	= new Button("I");
        
        //ʃCAEg
        HTMLLayout layout = new HTMLLayout();
		setLayoutManager(layout);
		
        layout.begin(HTMLLayout.CENTER);
		add(newBtn);    layout.br();
        add(listBtn);	layout.br();
        add(endBtn);	layout.br();
        layout.end();
        
        // Xi[o^
        setSoftKeyListener((SoftKeyListener)this);
        setKeyListener((KeyListener)this);
        setComponentListener(this);
        
        // {^
        checkSaveData();
    }

    /**
     * o^O̎A{^gps
     */
	public void checkSaveData()
	{
		DataWriter writer = new DataWriter();	// IO
		int count = writer.getSaveCount();		// ۑ擾
		listBtn.setEnabled(count > 0);			// 
	}
	/**
	 * \tgL[
	 */
    public void softKeyPressed(int softKey) {
    }
    
    /**
     * \tgL[ 
     */
    public void softKeyReleased(int softKey) {
    	// I
        if (softKey == SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

	/**
	 * L[
	 */
    public void keyPressed(Panel panel, int key) {
    }
    
    /**
     * L[
     */
    public void keyReleased(Panel panel, int key) {
        switch (key) {
            case Display.KEY_1:
                break;
            case Display.KEY_2:
                break;
            case Display.KEY_3:
                break;
            default:
                break;
        }
    }
    
    /**
     * R|[lg
     */
    public void componentAction(Component c, int type, int param) {
    	if ( c == endBtn ) {
    		// I{^
    		if ( type == ComponentListener.BUTTON_PRESSED ) {
    			IApplication.getCurrentApp().terminate();
    		}
    	} else if ( c == newBtn ) {
    		// VKo^iQFnull ŐVKj
    		newPanel = new RegistPanel(this, null);
    		Display.setCurrent(newPanel);
    	} else if ( c == listBtn ) {
    		// o^Xg{^
    		listPanel = new LoadDataPanel(this);
    		Display.setCurrent(listPanel);
    	}
    }
}

