

import java.util.Vector;
import java.lang.String;
import java.io.*;

import javax.microedition.io.Connector;
import java.util.Hashtable;

class DataWriter {
	DataWriter()
	{
	
	}
	
	/**
	 * 
	 * 1Byte: Count
	 * 2Byte: Size
	 * 3		- (3+Size   - 1) Byte: Data
	 * (3+Size): Size
	 *  - (3+Size*n - 1) Byte: Data2
	 *
	 *
	 */
	int write(int setCount, DataAll dataAll) {
		int pos;
		int count = getSaveCount();
		
		OutputStream output = null;
		Vector floors;
		DataFloor floor = null;
		DataAreaItem areaItem = null;
		
		int i, j, k, ksta;
		int iWrite = 0;
		
		if ( setCount == -1 ) {
			pos = count * 455 + 1;
		} else {
			pos = setCount * 455 + 1;
		}
		
		try {
			output = Connector.openOutputStream("scratchpad:///0;pos=" + pos);
			
			output.write(dataAll.areaPrefix 	); iWrite++;	//  16p( 32: 5bit)
			output.write(dataAll.areaSuffix 	); iWrite++;	//  16p( 32: 5bit) (+1)
			output.write(dataAll.areaEx 		); iWrite++;	//  24p( 32: 5bit)
			output.write(dataAll.areaSpace 		); iWrite++;	//   5p(  8: 3bit)	// [sum]18bit
			output.write(dataAll.areaLv 		); iWrite++;	//  99p(128: 7bit)
			output.write(dataAll.areaBoss 		); iWrite++;	//  12p( 16: 4bit)
			output.write(dataAll.areaPoint		); iWrite++;	//  31p( 64: 6bit)
			output.write(dataAll.areaInitMLv 	); iWrite++;	//  12p( 16: 4bit)	// [sum]39bit
			
			// floor count		 14p( 16p: 4bit)	// [sum]43bit
			
			// max: ( 156 + 5 ) * 14 = 2254bit
			// space count		  5p(  8p: 3bit) max: (33 + 2 + 4) * 4 = 156bit
				// space		 13p( 16p: 4bit) 
				// item count	  4p(  4p: 2bit) max: 11 * 3 = 33bit
					// type		  5p(  8p: 3bit)
					// item		256p(256p: 8bit)
			
			// [sum]2297bit = 288byte (287.125)
			
			for ( i = 3; i < 17; i++ ) {
				floors = (Vector) dataAll.floors.get(i + "");
				ksta = 0;
				if ( floors != null ) {
					for ( k = 0; k < floors.size(); k++ ) {
						floor = (DataFloor) floors.elementAt(k);
						output.write(floor.space[k][0]); iWrite++;
						output.write(floor.space[k][1]); iWrite++;
						
						for ( j = 0; j < floor.items.size(); j++ ) {
							areaItem = (DataAreaItem) floor.items.elementAt(j);
							if ( areaItem.uqnum.length() < 1 ) {
								output.write( 0 ); iWrite++;
							} else {
								output.write( Integer.parseInt(areaItem.uqnum) ); iWrite++;
							}
							output.write( areaItem.getSelIdx() ); iWrite++;
						}
						for ( j = floor.items.size(); j < 3; j++ ) {
							output.write( 0 ); iWrite++;
							output.write( 0 ); iWrite++;
						}
					}
					ksta = floors.size();
				}
				for ( k = ksta; k < 4; k++ ) {
					output.write(0); iWrite++;
					output.write(0); iWrite++;
					for ( j = 0; j < 3; j++ ) {
						output.write( 0 ); iWrite++;
						output.write( 0 ); iWrite++;
					}
				}
			}
			
			output.close();
			
			if ( setCount == -1 ) {
				output = Connector.openOutputStream("scratchpad:///0;pos=0");
				
				output.write( count + 1 );
				
				output.close();
			}
			
			System.out.println("iWrite:" +  iWrite);
		} catch (IOException e) {
	     	//e.printStackTrace();
		}
		return 0;
	}
	
	int read(DataAll dataAll) {
		
		return 0;
	}
	
	Vector reads() {
		InputStream input = null;
		int count = getSaveCount();
		int i, j, k, c;
		int pos;
		DataAll dataAll = null;
		Vector dataAlls = new Vector();
		Vector floors = null;
		int[] space = new int[2];
		DataFloor floor = null;
		int uqnum, selIdx;
		DataAreaItem areaItem;
		DataAreaItems dataAreaItems = new DataAreaItems();
		boolean isSet;
		int iRead;
		
		for ( c = 0; c < count; c++) {
			dataAll = new DataAll();
			pos = 455 * c + 1;
			
			try {
				iRead = 0;
				input = Connector.openInputStream("scratchpad:///0;pos=" + pos);
				
				dataAll.areaPrefix	= input.read(); iRead++;
				dataAll.areaSuffix	= input.read(); iRead++;
				dataAll.areaEx 		= input.read(); iRead++;
				dataAll.areaSpace 	= input.read(); iRead++;
				dataAll.areaLv 		= input.read(); iRead++;
				dataAll.areaBoss 	= input.read(); iRead++;
				dataAll.areaInitMLv = input.read(); iRead++;
				
				System.out.println("c=" + c +"area:" + dataAll.areaPrefix + ":" + dataAll.areaSuffix);
				//System.out.println("c=" + c +"space:" + space[0] + ":" + space[1]);
				for ( i = 3; i < 17; i++ ) {
					floors = null;
					for ( k = 0; k < 4; k++ ) {
						isSet = false;
						space[0] = input.read(); iRead++;
						space[1] = input.read(); iRead++;
						if ( space[0] == 0 ) {
							// data nothing
							for ( j = 0; j < 3; j++ ) {
								uqnum  = input.read(); iRead++;
								selIdx = input.read(); iRead++;
							}
						} else {
							// 
							floor = new DataFloor();
							
							floor.space[k][0] = space[0];
							floor.space[k][1] = space[1];
							
							for ( j = 0; j < 3; j++ ) {
								uqnum  = input.read(); iRead++;
								selIdx = input.read(); iRead++;
								if ( uqnum > 0 ) {
									areaItem = dataAreaItems.GetAreaItemFromUnique(Integer.toString(uqnum));
									areaItem.setSelIdx(selIdx);
									floor.items.addElement(areaItem);
									if ( isSet == false ) {
										floors = new Vector();
									}
									isSet = true;
									System.out.println("selIdx" + selIdx + ":uq" + uqnum);
								}
							}
							if ( isSet ) {
								floors.addElement(floor);
								System.out.println( "floors.addElement");
							}
						}
					}
					if ( floors != null && floors.size() > 0 ) {
						dataAll.floors.put( i + "", floors);
						System.out.println( "dataAll.floors.put" + i);
					}
				}
				input.close();
				System.out.println( "c = " + c + "/iRead" + iRead);
			} catch (IOException e) {
		     	dataAlls = null;
		     	//e.printStackTrace();
			}
			
			if ( dataAll.floors.size() > 0 ) {
				dataAll.setCount = c;
				dataAlls.addElement(dataAll);
			}
		}
		return dataAlls;
	}
	
	int getSaveCount() {
		InputStream input = null;
		int count = 0;
		try {
			input = Connector.openInputStream("scratchpad:///0;pos=0");
			if ( input == null ) {
				return 0;
			}
			count = input.read();
			input.close();
		} catch (IOException e) {
	     	count = 0;
	     	//e.printStackTrace();
		}
	    return count;
	}
}

