/*
 * NewRegist.java
 *
 * DATE : 2009/08/02 12:28
 */
import com.nttdocomo.ui.Panel;
import com.nttdocomo.ui.Display;
import com.nttdocomo.ui.IApplication;
import com.nttdocomo.ui.KeyListener;
import com.nttdocomo.ui.SoftKeyListener;


import com.nttdocomo.ui.*;

import java.util.Vector;
import java.lang.String;
import java.util.Hashtable;

/**
 * NewRegist
 *
 * @author NAME
 */
public class NewRegist extends Panel implements SoftKeyListener, KeyListener, ComponentListener
{
	private Panel prevPanel;
	private Panel selPanel;
	Label	lblLabel;
	/*
	ListBox List;
	*/
	
	private Label[][]	areaLbl = new Label[17][4];
	private Button[] areaBtn = new Button[17];
	private Button	saveBtn;
	private ListBox lstLv;
	ListBox lstPre;
	ListBox lstSuf;
	ListBox lstBos;
	ListBox lstSpa;
	ListBox lstEx;
	
	SuperDataArea dpre = new DataAreaPrefix();
	SuperDataArea dsuf = new DataAreaSuffix();
	SuperDataArea dbos = new DataAreaBoss();
	SuperDataArea dspa = new DataAreaSpace();
	SuperDataAreaMaps dexs = new DataAreaExs();
	
	
	DataAll dataAll = null;
	
    NewRegist(Panel prevPanel, DataAll setDataAll) {
    	int i;
    	
    	this.prevPanel = prevPanel;
    	
        setTitle("Start IApplication");
        
        if ( setDataAll == null ) {
        	dataAll = new DataAll();
        } else {
        	dataAll = setDataAll;
        }
        /**/
        /*
        lblLabel = new Label("");
		
		this.add(lblLabel);
		*/
		/**/
		/*
		List = new ListBox(ListBox.CHOICE);
		List.append("Ԗ");
		List.append("Ԗ");
		List.append("OԖ");
		this.add(List);
		*/
		
		lstLv = new ListBox(ListBox.CHOICE);
		for ( i = 1; i < 100; i++ ) {
			lstLv.append(i+"");
		}
		Font f = Font.getFont(Font.FACE_SYSTEM|Font.STYLE_PLAIN|Font.SIZE_TINY);
		lstLv.setSize( 25 + f.stringWidth("99"), lstLv.getHeight());
		lstLv.setFont( f );
		
		lstPre = dpre.GetList();
		lstSuf = dsuf.GetList();
		lstEx  = dexs.GetNameList("");
		lstSpa = dspa.GetList();
		lstBos = dbos.GetList();
		
		lstPre.select( dataAll.areaPrefix 	 );
		lstSuf.select( dataAll.areaSuffix 	 );
		lstEx.select(  dataAll.areaEx 		 );
		lstSpa.select( dataAll.areaSpace 	 );
		lstLv.select(  dataAll.areaLv 		 );
		lstBos.select( dataAll.areaBoss 	 );
		
		
		
		
        HTMLLayout layout = new HTMLLayout();
		setLayoutManager(layout);
		
        layout.begin(HTMLLayout.LEFT);
		this.add( lstPre );
		this.add( lstSuf );
		this.add( lstEx  );
        layout.br();
		this.add( lstSpa );
		this.add( lstLv );
        layout.br();
        
        saveBtn = new Button("ۑ");
        
        //areaBtn = new Button[17];
        /*
        if (areaBtn[0] == null) { 
        	lblLabel.setText("areaBtn == null");
        } else {
	        lblLabel.setText("areaBtn != null");
	        //areaBtn[0].setLabel( 0 + "F");
	    }
	    */
	    for ( i = 3; i < 17; i++ ) {
        	areaBtn[i] = new Button();
        	if ( i < 10 ) {
	        	areaBtn[i].setLabel( " " + i + "F");
	        } else {
	        	areaBtn[i].setLabel( i + "F");
	        }
        	this.add( areaBtn[i] );
        	layout.br();
        	
	        for ( int j = 0; j < 4; j++ ) {
	        	areaLbl[i][j] = new Label("", Label.LEFT);
	        	//areaLbl[i][j].setSize(this.getWidth() - 6, areaLbl[i][j].getHeight());
	        	areaLbl[i][j].setVisible(false);
	        	//areaLbl[i][j].setBackground(Graphics.getColorOfRGB(244,0,0));

	        	this.add( areaLbl[i][j] );
	        }
        	layout.br();
        }
        
		this.add( lstBos );
        layout.br();
        
        this.add( saveBtn );
        
        layout.end();
		
		/*
		lblLabel.setText(List.getWidth() + ":" + List.getHeight());
		*/
		//this.setComponentListener(new ListenerList(lblLabel,List));
		
		//L[Xi̐ݒ
		this.setKeyListener(this);
		this.setSoftKeyListener(this);
		
		//\tgL[̃xɕ\ݒ
		this.setSoftLabel(Frame.SOFT_KEY_1, "ۑ");
		this.setSoftLabel(Frame.SOFT_KEY_2, "f");
		
        setSoftKeyListener((SoftKeyListener)this);
        
        setKeyListener((KeyListener)this);
        setComponentListener(this);
        
        setDatas();
    }

    public void softKeyPressed(int softKey) {
    }
    
    public void softKeyReleased(int softKey) {
        if (softKey == SOFT_KEY_1) {
            save();
        } else {
        	IApplication.getCurrentApp().terminate();
        }
    }
    
    public void keyPressed(Panel panel, int key) {
    }
    
    public void keyReleased(Panel panel, int key) {
        switch (key) {
            case Display.KEY_1:
                break;
            case Display.KEY_2:
                break;
            case Display.KEY_3:
                break;
            default:
                break;
        }
    }
    
    public void save() {
		DataWriter writer = new DataWriter();
		dataAll.areaPrefix 	= lstPre.getSelectedIndex();
		dataAll.areaSuffix 	= lstSuf.getSelectedIndex();
		dataAll.areaEx 		= lstEx.getSelectedIndex();
		dataAll.areaSpace 	= lstSpa.getSelectedIndex();
		dataAll.areaLv 		= lstLv.getSelectedIndex();
		dataAll.areaBoss 	= lstBos.getSelectedIndex();
		
		writer.write( dataAll.setCount, dataAll);
        Display.setCurrent( prevPanel );
    }
    
    public void componentAction(Component c, int type, int param) {
    	if ( c == saveBtn ) {
    		save();
    	} else {
	    	for ( int i = 3; i < 17; i++ ) {
		    	if ( c == areaBtn[i] ) {
		    		selPanel = new SelectFloorItem(this, i, (Vector) dataAll.floors.get(i + ""));
	    			Display.setCurrent(selPanel);
	    			//System.out.println(dataAll);
	    			break;
		    	}
		    }
		}
    }
    public void setDatas() {
    	Vector floors = null;
    	DataFloor floor = null;
    	String space;
		DataAreaFloor dflr = new DataAreaFloor();
		DataAreaItems ditms = new DataAreaItems();
		
		int i, j, k;
		Vector itemNames = new Vector();
		String itemName;
		
		if ( dataAll.floors == null ) {
			System.out.println("dataAll.floors == null");
			return;
		}
		System.out.println("dataAll.floors.size()" + dataAll.floors.size());
    	if ( dataAll.floors.size() > 0 ) {
    		for ( i = 3; i < 17; i++ ) {
	    		floors = (Vector) dataAll.floors.get(i + "");
	    		if ( floors != null ) {
	    			System.out.println("floors is not null" + floors.size());
	    			for ( j = 0; j < floors.size(); j++ ) {
	    				floor = (DataFloor) floors.elementAt(j);
	    				if ( floor.space[j][0] != 0 ) {
	    					space = dflr.GetData(floor.space[j][0]);
	    					if ( floor.space[j][1] != 0 ) {
	    						space += "" + dflr.GetData(floor.space[j][1]);
	    					}
	    					if ( floor.items == null ) {
	    						break;
	    					}
	    					itemNames.removeAllElements();
	    					for ( k = 0; k < floor.items.size(); k++ ) {
		        				itemName = ((DataAreaItem) floor.items.elementAt(k)).name;
		        				itemNames.addElement(itemName);
			        		}
			        		
			    			setData( i, j, null, space,ditms.GetRankList(itemNames));
			    		} else {
			    			break;
			    		}
		    		}
	    		}
	    	}
	    }
    }
    public void setData(int floor, int num, DataFloor dataFloor, String space, String itemRank) {
    	Vector vecDataFloor;
    	
    	if ( dataFloor != null ) {
	    	if ( num == 0 ) {
	    		vecDataFloor = new Vector();
	    	} else {
		    	vecDataFloor = (Vector) dataAll.floors.get(floor + "");
		    	if ( vecDataFloor == null ) {
		    		vecDataFloor = new Vector();
		    	}
		    }
	    	vecDataFloor.addElement(dataFloor);
	    	dataAll.floors.put( floor + "", vecDataFloor);
    	}
    	areaLbl[floor][num].setText(space + "^Rank:" + itemRank);
    	areaLbl[floor][num].setSize(this.getWidth() - 6, areaLbl[floor][num].getHeight());
    	areaLbl[floor][num].setVisible(true);
    }
}
